print "__SAGE_BEGIN__256"
os.chdir("/Volumes/HOME/books/riemann_hypothesis/2006-08/sage_notebook/worksheets/sato_tate/cells/1")
#%auto
def dist(v, b, left=float(Integer(0)), right=float(pi)):
    """
    We divide the interval between left (default: 0) and
    right (default: pi) up into b bins.

    For each number in v (which must left and right),
    we find which bin it lies in and add this to a counter.
    This function then returns the bins and the number of
    elements of v that lie in each one.

    ALGORITHM: To find the index of the bin that a given
    number x lies in, we multiply x by b/length and take the
    floor.
    """
    length = right - left
    normalize = float(b/length)
    vals = {}
    d = dict([(i,Integer(0)) for i in range(b)])
    for x in v:
        n = int(normalize*(float(x)-left))
        d[n] += Integer(1)
    return d, len(v)
print "__SAGE_VARS__=%s"%_support_.variables(True)
print "__SAGE_END__256"
